--set list;
set heading off; 
select
	case 
        when a.master_id is null then a.id 
        when a.master_id is not null then a.master_id
    end || ';' || --ABONENT_ID <- считаем учетные записи доп. соглашения принадлежащими абоненту
	a.operator_id || ';' || --REGION_ID
	case
        when u.phone is not null then '6'
        when u.ip is not null or ipv6 is not null then '5'
    end || ';' || --IDENT_TYPE
	coalesce(u.phone,'') || ';' || --PHONE
	'' || ';' || --INTERNAL_NUMBER
	'' || ';' || --IMSI
	'' || ';' || --IMEI
	'' || ';' || --ICC
	'' || ';' || --MIN
	'' || ';' || --ESN
	'0' || ';' || --EQUIPMENT_TYPE
--<user-equipment    <mac>|<atm>		
--  <mac		
	coalesce(u.mac,'') || ';' || --MAC
--  mac>		
--  <atm		
	'' || ';' || --VPI
	'' || ';' || --VCI
--  atm>		
--user-equipment>		
	u.login || ';' || --LOGIN
	case 
        when a.master_id is null then a.email 
        when a.master_id is not null then a.master_id
    end || ';' || --E_MAIL
	'' || ';' || --PIN
	'' || ';' || --USER_DOMAIN
	'' || ';' || --RESERVED
	'' || ';' || --ORIGINATOR_NAME
	'0' || ';' || --IP_TYPE
--<ip-address    IPV4| IPV6		
	iif(u.ip is not null
        ,uf_ip2hex(u.ip)
        ,''
        ) || ';' || --IPV4
	'' || ';' || --IPV6
--ip-address>		
    '0' || ';' || --IP_MASK_TYPE, 0 = IPv4, 1 = IPv6
--<ip-mask	
    coalesce(u.mask,'') || ';' || --IPV4_MASK
	'' || ';' || --IPV6_MASK
--ip-mask>
	iif(u.ip is not null
        ,uf_ip2hex(u.ip)
        ,''
        ) || ';' || --IP_RANGE_START
	iif(u.ip is not null
        ,uf_ip2hex(u.ip)
        ,''
        ) || ';' || --IP_RANGE_END
	case 
        when a.master_id is null then a.id 
        when a.master_id is not null then a.master_id
    end || ';' || --INTERNAL_ID1
	case 
        when a.master_id is null then a.id 
        when a.master_id is not null then a.master_id
    end || ';' || --INTERNAL_ID2
    iif(a.activate_date is not null
        ,cast(cast(a.activate_date as date) as varchar(32)) || ' 00:00:00'
        ,'1970-12-31 23:59:59'
        ) || ';' || --BEGIN_TIME
    iif( coalesce(a.deleted,'0')=1
        ,cast(cast(a_del_date.block_date as date) as varchar(32)) || ' 00:00:00'
        ,''
        ) || ';' || --END_TIME
--<line-data		
	'' || ';' || --LINE_OBJECT
	'' || ';' || --LINE_CROSS
	'' || ';' || --LINE_BLOCK
	'' || ';' || --LINE_PAIR
	'' || ';' || --LINE_RESERVED
--line-data>		
--<last-location <mobile-location >|< wireless-location >|< geo-location >		
	'' || ';' || --LOC_TYPE
-- <mobile-location		
	'' || ';' || --LOC_LAC
	'' || ';' || --LOC_CELL
	'' || ';' || --LOC_TA
-- mobile-location >		
-- <wireless-location		
	'' || ';' || --LOC_CELL_WIRELESS
	'' || ';' || --LOC_MAC
-- wireless-location >		
-- <geo-location		
	'' || ';' || --LOC_LATITUDE
	'' || ';' || --LOC_LONGITUDE
	'' || ';' ||	-- LOC_PROJECTION_TYPE
-- geo-location >		
--<ip-location
    '' || ';' || --LOC_IP_TYPE
    '' || ';' || --LOC_IPV4
    '' || ';' || --LOC_IPV6
    '' --LOC_IP_PORT
--ip-location>
--last-location> 
from 
    users u 
join 
    abonents a 
    on u.abonent_id=a.id
left join
    (select distinct 
        abonent_id,
        cast(b_date as date) block_date
    from 
        abonents_block
    where 
        b_comment='Помещен в корзину') a_del_date on a.id=a_del_date.abonent_id -- <- при удалении учётки, она удаляется из базы
        -- а флаг users.deleted ставится только для учетных записей абонентов из корзины
        -- поэтому логика определения "удалён или нет" - такая же как в abonents.sql
left join 
    abonents a_master
    on a.master_id=a.id -- <- Учётки доп. соглашения считаем точками подключения основного договора
where 
    u.is_template=0
    and a.is_folder=0
    and u.id>0
    and a.id>0
;