set heading off;

--
--АКТИВНЫЕ УСЛУГИ
--
select distinct
    a.id || ';' || -- ABONENT_ID
    a.operator_id || ';' || -- REGION_ID
    uu.usluga_id  || ';' || -- ID
    cast(cast(UU.ENABLE_DATE as date) as varchar(32)) || ' 00:00:00' || ';' || -- BEGIN_TIME
    '2049-12-31 23:59:59' || ';' || -- END_TIME
    iif(uu.redirect_number is not NULL
        ,uu.redirect_number
        ,''
        ) || ';' || -- PARAMETER
    a.id || ';' || -- INTERNAL_ID1
    a.id -- INTERNAL_ID2
from 
    abonents a
join 
    users_usluga uu 
    on uu.abonent_id=a.id
join 
    usluga u 
    on u.id=uu.usluga_id
where 
    a.is_folder=0
    and a.id>0
    and a.deleted=0
    and u.deleted=0
    and uu.tarif_id is null 
    and uu.enabled=1
    and uu.deleted=0

union 

--
--УСЛУГИ, УДАЛЁННЫЕ ЗА ПРОШЕДШИЕ СУТКИ
--
select distinct
    a.id || ';' || -- ABONENT_ID
    a.operator_id || ';' || -- REGION_ID
    uu.usluga_id  || ';' || -- ID
    cast(cast(UU.ENABLE_DATE as date) as varchar(32)) || ' 00:00:00' || ';' || -- BEGIN_TIME
    cast(cast(ao.op_time as date) as varchar(32)) || ' 00:00:00' || ';' || -- END_TIME
    iif(uu.redirect_number is not NULL
        ,uu.redirect_number
        ,''
        ) || ';' || -- PARAMETER
    a.id || ';' || -- INTERNAL_ID1
    a.id -- INTERNAL_ID2
from 
    abonents a
join 
    users_usluga uu 
    on uu.abonent_id=a.id
join 
    usluga u 
    on u.id=uu.usluga_id
join audit_operations ao
    on uu.id=ao.object_id
    and uu.abonent_id=ao.abonent_id
    and ao.descr like 'Удалена услуга%'
where 
    a.is_folder=0
    and a.id>0
    and a.deleted=0
    and u.deleted=0
    and uu.tarif_id is null 
    and uu.deleted=1
    and cast(ao.op_time as date)=dateadd(-1 day to cast('now' as date))

;